<?php
// wcf imports
require_once(WCF_DIR.'lib/data/page/location/Location.class.php');

// wbb imports
require_once(WBB_DIR.'lib/data/thread/LatestPostsAndThreadsList.class.php');

/**
 * LatestPostsAndThreadsLocation is an implementation of Location for the latest posts and threads page.
 * 
 * @author 	Nerd Almighty
 * @copyright	2009 Bergwerk <http://bergwerk.forenberg.de>
 * @license	Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported <http://creativecommons.org/licenses/by-nc-sa/3.0/>
 * @package	com.bergwerk.wbb.page.user.latestPostsAndThreads
 * @subpackage	data.page.location
 * @category 	Burning Board
 */
class LatestPostsAndThreadsLocation implements Location {
	/**
	 * @see Location::cache()
	 */
	public function cache($location, $requestURI, $requestMethod, $match) {}
	
	/**
	 * @see Location::get()
	 */
	public function get($location, $requestURI, $requestMethod, $match) {
		$listID = (isset($match[2]) ? intval($match[2]) : 0);
		$list = ($listID ? new LatestPostsAndThreadsList($listID) : LatestPostsAndThreadsList::getDefaultList());
		
		if (!$list->canBeAccessed(true)) return '';
		
		return '<a href="index.php?page=LatestPostsAndThreads'.($listID ? '&amp;listID='.$listID : '').SID_ARG_2ND.'">'.WCF::getLanguage()->get($location['locationName']).'</a>';
	}
}
?>