<?php
// wcf imports
require_once(WCF_DIR.'lib/system/event/EventListener.class.php');

/**
 * Replaces dummy multiselect options with board select options.
 * 
 * @author 	Nerd Almighty
 * @copyright	2009 Bergwerk <http://bergwerk.forenberg.de>
 * @license	Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported <http://creativecommons.org/licenses/by-nc-sa/3.0/>
 * @package	com.bergwerk.wbb.page.user.latestPostsAndThreads
 * @subpackage	system.event.listener
 * @category 	Burning Board
 */
class UserProfileEditFormLatestPostsAndThreadsListener implements EventListener {
	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName) {
		if ($eventObj->activeCategory == 'settings.latestPostsAndThreads') {
			require_once(WBB_DIR.'lib/data/board/Board.class.php');
			$boardSelect = Board::getBoardSelect(array('canViewBoard'), true, true);
			$size = (count($boardSelect) > 10 ? 10 : count($boardSelect));
			
			if ($eventName == 'assignVariables') {
				// find relevant options
				foreach ($eventObj->options as $categoryKey => $categoryData) {
					foreach ($categoryData['options'] as $optionKey => $optionData) {
						if ($optionData['optionName'] == 'latestPostsAndThreadsDefaultListIncludedBoards' || $optionData['optionName'] == 'latestPostsAndThreadsDefaultListExcludedBoards') {
							// manipulate output html
							$user = WCF::getUser();
							$selected = $optionData['optionValue'];
							$html = '<select name="values['.$optionData['optionName'].'][]" id="'.$optionData['optionName'].'" multiple="multiple" size="'.$size.'">';
							foreach ($boardSelect as $boardID => $boardTitle) {
								$disabled = ($user->isIgnoredBoard($boardID) ? 'disabled="disabled" class="disabled" ' : '');
								$html .= '	<option '.$disabled.'value="'.$boardID.'"'.(in_array($boardID, $selected) && empty($disabled) ? ' selected="selected"' : '').'>'.$boardTitle.'</option>';
							}
							$html .= '</select>';
							$eventObj->options[$categoryKey]['options'][$optionKey]['html'] = $html;
						}
					}
				}
			}
			elseif ($eventName == 'validate') {
				// find relevant options
				foreach ($eventObj->activeOptions as $optionName => $optionData) {
					if ($optionName == 'latestPostsAndThreadsDefaultListIncludedBoards' || $optionName == 'latestPostsAndThreadsDefaultListExcludedBoards') {
						// manipulate selectoptions to allow validation
						$selectOptions = '0:0';
						foreach ($boardSelect as $boardID => $boardTitle) {
							$selectOptions .= "\n".$boardID.':'.$boardID;
						}
						$eventObj->activeOptions[$optionName]['selectOptions'] = $selectOptions;
					}
				}
			}
		}
	}
}
?>